"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var PactProviderCoreModule_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PactProviderCoreModule = void 0;
const common_1 = require("@nestjs/common");
const pact_verifier_service_1 = require("../services/pact-verifier.service");
const pact_verifier_provider_1 = require("../providers/pact-verifier.provider");
const pact_module_providers_enum_1 = require("../common/pact-module-providers.enum");
const provider_factory_1 = require("../common/provider-factory");
let PactProviderCoreModule = PactProviderCoreModule_1 = class PactProviderCoreModule {
    static register(options) {
        const optionsProvider = provider_factory_1.ProviderFactory.create(pact_module_providers_enum_1.PactModuleProviders.ProviderOptions, options);
        return {
            module: PactProviderCoreModule_1,
            exports: [pact_verifier_service_1.PactVerifierService],
            providers: [pact_verifier_provider_1.PactVerifierProvider, optionsProvider, pact_verifier_service_1.PactVerifierService],
        };
    }
    static registerAsync(options) {
        return {
            exports: [pact_verifier_service_1.PactVerifierService],
            imports: options.imports,
            module: PactProviderCoreModule_1,
            providers: [...this.createAsyncProviders(options), pact_verifier_provider_1.PactVerifierProvider, pact_verifier_service_1.PactVerifierService],
        };
    }
    static createAsyncProviders(options) {
        if (options.useExisting || options.useFactory) {
            return [this.createAsyncOptionsProvider(options)];
        }
        const { useClass } = options;
        return [
            this.createAsyncOptionsProvider(options),
            {
                provide: useClass,
                useClass,
            },
        ];
    }
    static createAsyncOptionsProvider(options) {
        if (options.useFactory) {
            return {
                inject: options.inject || [],
                provide: pact_module_providers_enum_1.PactModuleProviders.ProviderOptions,
                useFactory: options.useFactory,
            };
        }
        const inject = [(options.useClass || options.useExisting)];
        return {
            provide: pact_module_providers_enum_1.PactModuleProviders.ProviderOptions,
            useFactory: async (optionsFactory) => await optionsFactory.createPactProviderOptions(),
            inject,
        };
    }
};
PactProviderCoreModule = PactProviderCoreModule_1 = __decorate([
    common_1.Module({})
], PactProviderCoreModule);
exports.PactProviderCoreModule = PactProviderCoreModule;
//# sourceMappingURL=pact-provider-core.module.js.map